procedure err(s:string);
begin
  if run1=1 then write(dialect,'.',run2:1,': ') else write('Run #',run1:1,'.',run2:1,': ');
  writeln(s);
  OK:=False
end;

{$define TO1(typ,vr)
  if IOResult<>0 then err('unexpected I/O error while reading '+typ+' variable')
}
{$define TO0(typ,vr,val)
  begin TO1(typ,vr) else if not (vr=val) then begin writestr(tmpstr,'value of '+typ+' variable is `',vr,''', but should be `',val,'''');err(tmpstr) end end
}

{$define TW(typ,vr)
  begin if IOResult=0 then err('unexpected I/O success while reading '+typ+' variable') end
}

{$define GO1(typ,vr) begin get(vr);TO1(typ,vr) end}
{$define GO(typ,vr,val) begin get(vr);TO0(typ,vr,val) end}
{$define GW(typ,vr) begin get(vr);TW(typ,vr) end}

{$define TestInt(typ,var)
  GO(typ,var,42);
  if Hex  then GO(typ+' (Hex)',var,62) else GW(typ+' (Hex)',var);
  if Base then GO(typ+' (Base)',var,93) else if valf then GW(typ+' (Base)',var) else GO(typ+' (Base)',var,19);
  if not (White or valf) then GO(typ+' (White)',var,24) else GW(typ+' (White)',var);
  if not (White or valf) and Hex then GO(typ+' (White, Hex)',var,17) else GW(typ+' (White, Hex)',var);
  if White or valf then GW(typ+' (White, Base)',var) else if Base then GO(typ+' (White, Base)',var,116) else GO(typ+' (White, Base)',var,11);
  GW(typ+' (Invalid)',var);
  if not RangeCheck then GO1(typ+' (Range)',var) else GW(typ+' (Range)',var)
}

{$define TestReal(typ,var)
  GO(typ+' (1)',var,173.25);
  GO(typ+' (2)',var,-17326000);
  GW(typ+' (Invalid)',var);
  GO(typ+' (3)',var,-0.125);
  if not RealIso7185 then GO(typ+' (EP, 1)',var,0.5) else GW(typ+' (EP, 1)',var);
  if not RealIso7185 then GO(typ+' (EP, 2)',var,-0.25) else GW(typ+' (EP, 2)',var);
  if not (White or valf) then GO(typ+' (White)',var,-2.3e16) else GW(typ+' (White)',var);
  if not (White or valf) and not RealIso7185 then GO(typ+' (White, EP)',var,2e-14) else GW(typ+' (White, EP)',var);
}

(*
  We split these tests into separate files, because some systems have
  problems compiling the otherwise quite large (preprocessed) test
  program (e.g., virtual memory exceeded under DJGPP). However, even
  the large test in a single file has worked fine, e.g., on a Linux
  system with enough RAM and temp space.
*)

{$define TestNum1  TestInt('ByteInt',bi);}
{$define TestNum2  TestInt('ShortInt',si);}
{$define TestNum3  TestInt('Integer',ni);}
{$define TestNum4  TestInt('MedInt',mi);}
{$define TestNum5  TestInt('LongInt',li);}
{$define TestNum6  TestInt('Byte',bc);}
{$define TestNum7  TestInt('ShortCard',sc);}
{$define TestNum8  TestInt('Cardinal',nc);}
{$define TestNum9  TestInt('MedCard',mc);}
{$define TestNum10 TestInt('LongCard',lc);}
{$define TestNum11 TestReal('ShortReal',sr);}
{$define TestNum12 TestReal('Real',nr);}
{$define TestNum13 TestReal('LongReal',lr);}

{$define CONCAT1(A,B) A##B}
{$define CONCAT(A,B) CONCAT1(A,B)}

{$define TestNum
  inc(run2);
  reset(infile);
  if IOResult<>0 then begin writeln('Could not open input file.'); Halt(1) end;
  CONCAT(TestNum,DoTestNum);
}

{$ifdef Standard}
{$define TestCString}
{$else}
{$define TestCString
  get(cst);TO1('CString',cst) else if strcmp(cst,'fof')<>0 then begin writestr(tmpstr,'value of CString variable is `',cst,''', but should be `fof''');err(tmpstr) end
}
{$endif}

{$define TestAll
  TestNum;
  GO('Char',c,'a');
  GO('Char',c,chr(0));
  get2(c,c2);
  TO0('Char (1)',c,'f');
  TO0('Char (2)',c2,'o');
  GO('Char (R)',cr,'M');
  if not RangeCheck then GO1('Char (Range)',cr) else GW('Char (Range)',cr);
  if run2=3 then GO('String',nst,'foo'+Chr(0)+'b ar '+StringOfChar(' ',GetStringCapacity(nst)-9)) else GO('String',nst,'foo'+Chr(0)+'b ar ');
  if run2=3 then GO('ShortString',sst,'oof'+Chr(0)+'ra b '+StringOfChar(' ',GetStringCapacity(sst)-9)) else GO('ShortString',sst,'oof'+Chr(0)+'ra b ');
  GO('FixedString',fst,'ofo'+Chr(0)+'ba r'+StringOfChar(' ',SizeOf(fst)-8));
  TestCString
}

procedure r;
begin
  {$i-}
  run1:=0;
  {$i readsub.inc}
  {$no-read-base-specifier}
  {$no-read-hex}
  {$no-read-white-space}
(*@@not implemented yet
  {$no-read-range-checking}
*)
  rangecheck:=False;
  base      :=False;
  hex       :=False;
  whitespace:=False;
  {$i readsub.inc}
  {$read-base-specifier}
  {$read-hex}
  {$read-white-space}
(*@@not implemented yet
  {$read-range-checking}
  rangecheck:=True;
*)
  base      :=True;
  hex       :=True;
  whitespace:=True;
  {$i readsub.inc}
  {$i+}
end;

{$gnu-pascal}

procedure test;
begin
  Rewrite(infile);
  #if DoTestNum <= 10
  writeln(infile,'42');
  writeln(infile,'$3e');
  writeln(infile,'19#4h');
  writeln(infile,'24:');
  writeln(infile,'$000000011,x');
  writeln(infile,'  '#9#9'  11#A6~');
  writeln(infile,'foo');
  if DoTestNum=10 then writeln(infile,'-1') else writeln(infile,'10000000000000000000');
  #else
  writeln(infile,'17.325e1');
  writeln(infile,'-17.326E6');
  writeln(infile,'one point two');
  writeln(infile,'-125e-3');
  writeln(infile,'.5');
  writeln(infile,'-.25');
  writeln(infile,'-23e15$');
  writeln(infile,'.2e-13%');
  #endif
  writeln(infile,'a');
  writeln(infile,#0);
  writeln(infile,'fo');
  writeln(infile,'M');
  writeln(infile,'m');
  writeln(infile,'foo'#0'b ar ');
  writeln(infile,'oof'#0'ra b ');
  writeln(infile,'ofo'#0'ba r ');
  writeln(infile,'fof'#0'r ab ');
  OK:=True;
  r;
  if OK then WriteLn('OK')
end;
